/*
 * Copyright (c) 2001 Fenris, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/* 
 * File:  callbacks.h
 *
 * Purpose:  This header file contains the definitions required for 
 * the event functionality of the gui portion of the network
 * monitoring tool
 *
 */


#include <gtk/gtk.h>

#define RATE_BPS        0
#define RATE_KBPS       1
#define RATE_MBPS       2
#define RATE_GBPS       3

GtkLabel *statusbar;

void draw(GtkWidget *widget);
gint draw_timer(gpointer data);
gboolean event_configure(GtkWidget *widget,
                         GdkEventConfigure *event, gpointer data);
gboolean event_expose(GtkWidget *widget, GdkEventExpose *event, gpointer data);
void event_destroy(GtkObject *object, gpointer data);


void on_file_exit_activate                  (GtkMenuItem     *menuitem,
                                             gpointer         user_data);

void on_f_arp_all_activate                  (GtkMenuItem     *menuitem,
                                             gpointer         user_data);

void on_f_ip_all_activate                   (GtkMenuItem     *menuitem,
                                             gpointer         user_data);

void on_f_ip_icmp_all_activate              (GtkMenuItem     *menuitem,
                                             gpointer         user_data);

void on_f_ip_igmp_all_activate              (GtkMenuItem     *menuitem,
                                             gpointer         user_data);

void on_f_ip_tcp_all_activate               (GtkMenuItem     *menuitem,
                                             gpointer         user_data);

void on_f_ip_udp_all_activate               (GtkMenuItem     *menuitem,
                                             gpointer         user_data);

void on_f_ip_icmp_request_activate          (GtkMenuItem     *menuitem,
                                             gpointer         user_data);

void on_f_ip_icmp_reply_activate            (GtkMenuItem     *menuitem,
                                             gpointer         user_data);

void on_f_ip_icmp_pair_activate             (GtkMenuItem     *menuitem,
                                             gpointer         user_data);

void on_f_ip_tcp_http_activate              (GtkMenuItem     *menuitem,
                                             gpointer         user_data);

void on_f_ip_tcp_ftp_activate               (GtkMenuItem     *menuitem,
                                             gpointer         user_data);

void on_f_ip_tcp_ssh_activate               (GtkMenuItem     *menuitem,
                                             gpointer         user_data);

void on_f_ip_port_activate                  (GtkMenuItem     *menuitem,
                                             gpointer         user_data);

void on_f_ip_tcp_port_activate              (GtkMenuItem     *menuitem,
                                             gpointer         user_data);

void on_f_ip_udp_port_activate              (GtkMenuItem     *menuitem,
                                             gpointer         user_data);

void on_file_options_activate               (GtkMenuItem     *menuitem,
                                             gpointer         user_data);

void on_file_clear_dns_activate             (GtkMenuItem     *menuitem,
                                             gpointer         user_data);

void on_option_ok_clicked                   (GtkButton       *button,
                                             gpointer         user_data);

void on_options_cancel_clicked              (GtkButton       *button,
                                             gpointer         user_data);

void on_f_all_activate                      (GtkMenuItem     *menuitem,
                                             gpointer         user_data);

void on_by_address_activate                 (GtkMenuItem     *menuitem,
                                             gpointer         user_data);

void on_filter_ok_clicked                   (GtkButton       *button,
                                             gpointer         user_data);

void on_filter_cancel_clicked               (GtkButton       *button,
                                             gpointer         user_data);

void set_status_bar_text		    ();
