/*
 * Copyright (c) 2001 Fenris, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
#ifndef _DB_H
#define _DB_H

#include <mysql/mysql.h>
#include <sys/time.h>

#include "headers.h"
#include "queue.h"

#define DB_INFO_LEN     128
#define DB_MYSQL        1


STAILQ_HEAD(stailhead, db_item) db_q;

struct db_info {
    char                        *user;
    char                        *passwd;
    char                        *host;
    unsigned int                 port;
    char                        *db;
    unsigned int                 type;
};

struct db_item {
    Packet_Headers              *p;
    struct timeval               ts;
    STAILQ_ENTRY(db_item)        entries;
};


void into_db(Packet_Headers *p, struct timeval *ts);
void init_db(struct db_info **db, char *filename);
void *db_engine(void *arg);
void insert_mysql(MYSQL *mysql, struct db_item *item);

#endif /* _DB_H */
